// C Source File
// Created 13/03/2006; 23:00:32
/*Auteur: Cy Brown
**E-mail: nevada51@hotmail.fr
**version 1.0
**Thanks to Pascal MARTIN for his tutorial and to the TIGCC team*/

#define SCREEN_WIDTH 159
#define SCREEN_HEIGHT 99

#include <tigcclib.h>

void msgbox(char **strLst,short nbLine);

void _main(void)
{
  ESI argptr = top_estack;
  unsigned short nbLine = min(ArgCount(),(unsigned int)9);
  char** strLst = (char**)malloc(nbLine*sizeof(char*));
  unsigned short i;
  for(i=0;i<nbLine;i++)
  {
  	if (GetArgType(argptr)!=STR_TAG)
  	{
  		ST_helpMsg("!!! Erreur d'arguments");
  		exit(0);
  	}
  	strLst[i] = GetStrnArg(argptr);
  }
  msgbox(strLst,nbLine);			//Dessine la boite de dialogue
}

void msgbox(char **strLst,short nbLine)
{
  //Dclaration des variables:
  short i;
  short oldFont = FontGetSys();
  short height = DrawStrWidth(strLst[0],F_6x8);
  //height = 100;
  if (nbLine != 1)
  {
  	for (i=0;i<(nbLine-1);i++)
	  {
	  	if (DrawStrWidth(strLst[i],F_6x8)<DrawStrWidth(strLst[i+1],F_6x8))
	  		height = DrawStrWidth(strLst[i+1],F_6x8);
	  }
  }
  height += 2;
  height = max(height,30);
  short x1 = max(SCREEN_WIDTH/2-height/2,0);
  short x2 = min(x1+height,SCREEN_WIDTH);
  short y1 = max(SCREEN_HEIGHT/2-(12+8*nbLine)/2,0);
  short y2 = min(y1+12+8*nbLine,SCREEN_HEIGHT);;
  unsigned short taille = BitmapSize(&(SCR_RECT){{x1,y1,x2,y2}});
	unsigned char *buffer = malloc(taille);
	if(buffer)
	{
	  //Sauvegarde de la zone qui va tre efface:
		BitmapGet(&(SCR_RECT){{x1,y1,x2,y2}}, buffer);
  	//Efface le futur emplacement de la fentre:
  	ScrRectFill(&(SCR_RECT){{x1,y1,x2,y2}},&(SCR_RECT){{x1,y1,x2,y2}},A_REVERSE);
  	//Cadre de la fentre:
		DrawLine(x1+2,y1,x2-2,y1,A_NORMAL);
		DrawLine(x2,y1+2,x2,y2-2,A_NORMAL);
		DrawLine(x2-2,y2,x1+2,y2,A_NORMAL);
		DrawLine(x1,y2-2,x1,y1+2,A_NORMAL);
		DrawPix(x1+1,y1+1,A_NORMAL);
		DrawPix(x2-1,y1+1,A_NORMAL);
		DrawPix(x2-1,y2-1,A_NORMAL);
		DrawPix(x1+1,y2-1,A_NORMAL);
		//Dessin des lignes de titre:
		DrawLine(x1,y1+8,x2,y1+8,A_NORMAL);
		DrawLine(x1,y1+10,x2,y1+10,A_NORMAL);
		//Ecriture du titre:
		FontSetSys(F_4x6);
		DrawStr(SCREEN_WIDTH/2-DrawStrWidth("Message",F_4x6)/2,y1+2,"Message",A_NORMAL);
		FontSetSys(F_6x8);
		//Ecriture des chaines:
		for (i=0;i<nbLine;i++)
			DrawStr(SCREEN_WIDTH/2-DrawStrWidth(strLst[i],F_6x8)/2,y1+12+i*8,strLst[i],A_NORMAL);
		FontSetSys(oldFont);
		ngetchx();
		ScrRectFill(&(SCR_RECT){{x1,y1,x2,y2}},&(SCR_RECT){{x1,y1,x2,y2}},A_REVERSE);
		BitmapPut(x1, y1, buffer, ScrRect, A_NORMAL);
		free(buffer);
	}
	else
	{
		ST_helpMsg("!!!!! Allocation impossible !!!!!");
		ngetchx();
	}
}